Description: Bonjour,

J’aime proposer des questions a données aléatoires et parfois il arrive que mes choix de bonnes et
mauvaises réponses soient identiques si je n’ai pas bien anticipé tous les choix.

Or cela ne génére pas d’erreur au niveau de la création des sujets, donc ¢a passe inapergu jusqu’a ce qu’un
étudiant la signale.

Serait-il possible d’inclure un test sur les questions simples ou multiples pour s’assurer que toutes les
mauvaises réponses ne correspondent pas a une bonne ? Et stopper la création des sujets avec comme
erreur : « une bonne réponse et une mauvaise ont la méme valeur »

D’avance merci.

History

03/07/2020 12:11 pm - Frédéric Bréal

Avec le paquet @fp@, je vous propose ceci :
<pre>

\begin{question}{03}

Quelle est la bonne réponse :

\FPeval\VQA({trunc(3+1*random,2)}
\FPeval\VQB{trunc }
\FPeval\VQC{trunc }
\FPeval\VQD({trunc(3+1*random,2)}

3+1*random,2
3+1*random,2

( )
( )
( )
( )

\FPifeqg \VQA \VQB \FPeval\VQB({trunc(3+12*random,2)} \else \relax\fi
\FPifeq \WVQA \VQC \FPeval\VQC{trunc(3+12*random,2)} \else \relax\fi
\FPifeqg \VQA \VQD \FPeval\VQD({trunc(3+12*random,2)} \else \relax\fi

\begin{reponses}[o]
\bonne{\VQA}
\mauvaise{\VQB}
\mauvaise{\VQC}
\mauvaise{\VQD}
\end{reponses}
\end{question}

</pre>
Les mauvaises réponses ne sont pas comparées.

03/07/2020 09:55 pm - Jean-claude Lhote
Gérard Carpeaux wrote:

> Avec le paquet @fp@, je vous propose ceci :
>

> Les mauvaises réponses ne sont pas comparées.

JE ne suis pas un spécialiste de Latex, et encore moins du package fp, mais dans votre proposition, si je comprends bien :
si \VQA est égal a \VQB, alors il choisit une autre valeur aléatoirement pour \VQB... il y a une faille si il choisi a nouveau la méme valeur (je sais, il y a

peu de chances... 1/1000 environ, mais 1/1000 n'est pas zéro). Ce qu'il faudrait c'est un "tant que \VQA est égal a \VQB"

Me trompe-je ?

En tout cas merci de votre proposition, ¢ca me permet de progresser en Latex.
Je pourrais plutét faire ce test en utilisant Pythontex... et dans ce cas, le while existe.

Peut-étre une solution avec ¢a ? :

\ifFPtest ...\else...\fi % repeat last test

La documentation de fp est vraiment trés minimaliste :-(

03/08/2020 10:46 am - Frédéric Bréal

> il y a une faille si il choisi a nouveau la méme valeur

oui et j'ai eu la méme idée avec

> le while existe.

<pre>

\whiledo{ \VQA = \VQB}{\FPeval\VQB{trunc(3+12*random,2)}}

</pre>

Malheureusement ce code ne compile pas.

> La documentation de fp est vraiment trés minimaliste :-(

Dans la documentation d'AMC, a la section Divers, j'ai fait une documentation qui n'est plus forcément correcte car elle date de ma découverte de latex
et AMC en 2013 et donc des erreurs peuvent restées dues a mon incompréhension, je pense a la fonction upn. Sur ctan.org, il y a eu une petite mise

en page qui facilite la lecture.

03/08/2020 11:05 pm - Jean-claude Lhote

Gérard Carpeaux wrote:

>> il y a une faille si il choisi a nouveau la méme valeur

> oui et j'ai eu la méme idée avec

> > |e while existe.

> Malheureusement ce code ne compile pas.

> > La documentation de fp est vraiment trés minimaliste :-(

> Dans la documentation d'AMC, a la section Divers, j'ai fait une documentation qui n'est plus forcément correcte car elle date de ma découverte de
latex et AMC en 2013 et donc des erreurs peuvent restées dues a mon incompréhension, je pense a la fonction upn. Sur ctan.org, il y a eu une petite

mise en page qui facilite la lecture.

Merci.

Je vais partir sur la solution pythontex... j'ai un peu de mal avec Latex encore.
Je vais tester sur les prochains sujets.

Cordialement.

03/24/2020 12:01 pm - Alexis Bienveniie
- Tracker changed from Bug to Feature
